#version 330 core

layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;

layout(std140) uniform Matrices
{
  mat4 mMat;
  mat4 vMat;
  mat4 pMat;
};

in vsData
{
  vec3 fragPos;
  vec3 normal;
}
gsIn[];

out gsData
{
  vec3 fragPos;
  vec3 normal;
  vec3 baryCoord;
}
gsOut;

vec3 baryCoords[3] = vec3[](vec3(1, 0, 0), vec3(0, 1, 0), vec3(0, 0, 1));

void main()
{
  vec4 triangleCenter =
      (gl_in[0].gl_Position + gl_in[1].gl_Position + gl_in[2].gl_Position) /
      3.0;

  for (int i = 0; i < gl_in.length(); i++)
  {
    vec4 originPos = gl_in[i].gl_Position - triangleCenter;
    originPos *= 0.85;
    originPos += triangleCenter;

    // gl_Position = gl_in[i].gl_Position;
    gl_Position = pMat * vec4(originPos.xyz, 1);
    gsOut.fragPos = gsIn[i].fragPos;
    gsOut.normal = gsIn[i].normal;
    gsOut.baryCoord = baryCoords[i];
    EmitVertex();
  }
  // gl_Position = gl_in[1].gl_Position;
  // gsOut[1].fragPos = gsIn[1].fragPos;
  // gsOut[1].normal = gsIn[1].normal;
  // EmitVertex();
  // gl_Position = gl_in[2].gl_Position;
  // gsOut[2].fragPos = gsIn[2].fragPos;
  // gsOut[2].normal = gsIn[2].normal;
  // EmitVertex();
  EndPrimitive();
}
